//+------------------------------------------------------------------+
//|                                            Volume Correction.mq4 |
//|                                                           Kirill |
//|                                          StockProgrammer@mail.ru |
//+------------------------------------------------------------------+
#property copyright "Kirill"
#property link      "StockProgrammer@mail.ru"

#define SEC_WAIT 10
#define MS_WAIT 100

//v3.0 = v2.0 + IsTradeAllowed()
//v5.0 = v4.2 (Igonter) +   (AntFX)

//#
/*
:   

  ,            .        .

:
1. ,       . 
2. ,       . 
3.       :
   1.    
   2.      
   3.      
   4.       
   5.        

:
         .
D = _ / ( - _).
 D > 0  1,     .
 D < 0  2,     .
.

 .
          : V =    -   .
  ,  V <> 0     V * D,    V     .

 .
    V.
    ,    C.

,    3 :
1.  V   . 
2.     ,           .  ,       . 
3.  2,        . 
4.  2,      . 
5.  2,        . 

       ,          .
 ,  -    . 

// v5.0

    -


CorrPendings -    /
MinIncrease -    ,     
MinDecrease -    ,     
MinDistance -         ,     . 
      ,     ,      , 
      ,     .
ForcedDecrease -         ,    ,     
PendMode -    
   0 -      
   1 -        (   ,   )
   2 -         (  ,   ,   )
*/

//# 
//
extern   string   Comment1       =  ":       ?";
extern   bool     AllowIncrease  =  true;    
extern   string   Comment2       =  ":       ?";
extern   bool     AllowDecrease  =  true;
//
extern   string   Comment3       =  "      .";
extern   int      Mode           =  1;
extern   string   Comment31      =  "   (   )";
extern   int      ModeMTS        =  1;
extern   string   Comment32      =  " Market Execution (   NDD)";
extern   int      ModeMarket     =  1; 
// 
extern   string   Comment4       =  "-  -  .   . 0 -  .";
extern   int      StopLoss       =  0;
extern   int      TakeProfit     =  0;
extern   double   MinDiffPercent =  3;
//  
extern   string   Comment5       =  "   ";
extern   bool     CorrPendings   =  false;
extern   int      MinIncrease    = 3;
extern   int      MinDecrease    = 1;
extern   int      MinDistance    = 100;
extern   int      ForcedDecrease = 20;
extern   int      PendMode       = 2;
//    
extern   string   Comment6       = "     (ModeMTS=1)";
extern   bool     ReplaceComment = false;
extern   bool     ChainClosing   = false;
extern   bool     ChainSLTP      = false;
extern   int      Rounding       = 1;


//# 
//
int            slip           =  3;
//
double            D              =  0.0;
datetime          LastBalOp      =  0;
bool b;

//# 
string            SymbolArray[1000];
int               Ticket[1000];
double            Ticket2[1001][4];                                     //[1000]   - temporary storage
double            SymAsk, SymBid;
//#   
int init()
{
   LastBalOp = TimeCurrent();                                           //       
   return(0);
}

int start()
{
   CheckD();
   if(D > 0.0 && MathAbs(D)>=MinDiffPercent/100 && AllowIncrease == true)
      Increase();
   if(D < 0.0 && MathAbs(D)>=MinDiffPercent/100 && D > -1 && AllowDecrease == true)
      Decrease();
   if(CorrPendings && ((D>0 && D*100>=MinIncrease) || (D<0 && D>-1 && -D*100>=MinDecrease)))
      DoPendings();
   if(D <= -1)
      Print("D<1, Doing nothing");
   D = 0.0;
   if(ChainClosing)
      CheckCloseOrders();
   return(0);
}

void CheckCloseOrders()
{
   for(int i=OrdersTotal()-1; i>=0; i--)
   {
      b=OrderSelect(i, SELECT_BY_POS);
      if(OrderType()>1) continue;
      if(StringSubstr(OrderComment(), 0, 3)=="CR:")
      {
         int _new=OrderTicket();
         int tick=StrToDouble(StringSubstr(OrderComment(), 3));
         if(tick>0)
         {
            if(OrderSelect(tick, SELECT_BY_TICKET))
            {
               if(OrderCloseTime()>0)
               {
                  Print("Closing ticket ", _new, " because original order ", tick, " was closed...");
                  b=OrderSelect(_new, SELECT_BY_TICKET);
                  b=OrderClose(OrderTicket(), OrderLots(), OrderClosePrice(), 1000);
               }
               else
               {
                  if(ChainSLTP)
                  {
                     double sl=OrderStopLoss();
                     double tp=OrderTakeProfit();
                     b=OrderSelect(_new, SELECT_BY_TICKET);
                     if(MathAbs(OrderStopLoss()-sl)>=MarketInfo(OrderSymbol(), MODE_POINT) || MathAbs(OrderTakeProfit()-tp)>=MarketInfo(OrderSymbol(), MODE_POINT))
                     {
                        b=OrderModify(_new, OrderOpenPrice(), sl, tp, 0);
                     }
                  }
               }
            }
         }
      }
   }
}

void CheckD()
{  
   int total, i;
   double Balance_Change = 0.0, Equity;
   datetime time = 0;
   
   total=OrdersHistoryTotal();
   for(i=0; i<total; i++)      
   {
      b=OrderSelect(i, SELECT_BY_POS, MODE_HISTORY);
      if(OrderType()==6)                          //
         if(OrderOpenTime()>LastBalOp)                                  //.
            {
               Balance_Change += OrderProfit();
               if(OrderOpenTime() > time)
                  time = OrderOpenTime();                               //   LastBalOp
            }
   }

   if(time != 0)
      LastBalOp = time; 
   
   Equity = AccountEquity();
 
   D = Balance_Change / (Equity - Balance_Change); 
}


void Increase()
{
   int S, i, total, j, res;
   double V, lots, lot;
   double Minlot, Lotstep, Maxlot;
   double price, sl, tp;
   string sym, comm;
   bool resb;
   
   if (ModeMTS==1)
   {
      total = CreateTicketArraySymbol(999, ""); 
      for(j=0; j<total; j++)
      {
         b=OrderSelect(Ticket[j], SELECT_BY_TICKET);
         sym = OrderSymbol();
         Minlot   =  MarketInfo(sym, MODE_MINLOT);
         Lotstep  =  MarketInfo(sym, MODE_LOTSTEP);
         slip     =  MarketInfo(sym, MODE_SPREAD); 
         lot = D*OrderLots();         
         lot = (Rounding==1?MathFloor(lot/Lotstep):Rounding==2?MathCeil(lot/Lotstep):MathRound(lot/Lotstep))*Lotstep;
         Print("Volume Correction: increasing lot: ", lot);   
         if(lot < Minlot)
         {
            Print("Volume Correction: Can not increase position ", OrderTicket(), " because increasing lot is < minlot"); 
         }                 
         else
         {
            while(!IsTradeAllowed())
            {
               if(IsStopped()==true) return;
               Print("Trade is not allowed. Sleeping 1sec");
               Sleep(1000);
            }  
            RefreshRates();   
            SymBid = MarketInfo(sym,MODE_BID);
            SymAsk = MarketInfo(sym,MODE_ASK);
            if(!ReplaceComment)
               comm=OrderComment();
            else
               comm="CR:"+DoubleToStr(OrderTicket(), 0);
            if (ModeMarket==0)
            {
               if (OrderType()==OP_BUY)                    
                  res = OrderSend(sym, OP_BUY, lot, SymAsk, slip, OrderStopLoss(), OrderTakeProfit(), comm,OrderMagicNumber(),OrderExpiration());
               else    
                  res = OrderSend(sym, OP_SELL, lot, SymBid, slip, OrderStopLoss(), OrderTakeProfit(), comm,OrderMagicNumber(),OrderExpiration());
               if(res < 0) Print("Volume Correction: OrderSend() Error: ", GetLastError());
               else        Print("Volume Correction: Volume increased. New order ticket: ", res);            
            }
            else
            {
               if (OrderType()==OP_BUY)                    
                  res = OrderSend(sym, OP_BUY, lot, SymAsk, slip, 0, 0, comm,OrderMagicNumber(),0);
               else    
                  res = OrderSend(sym, OP_SELL, lot, SymBid, slip, 0, 0, comm,OrderMagicNumber(),0);
               if (res < 0) Print("Volume Correction: OrderSend() Error: ", GetLastError());
               else if (OrderStopLoss()!=0 || OrderTakeProfit()!=0)        
               {
                  Print("Volume Correction: Volume increased. New order ticket: ", res);                 
                  while(!IsTradeAllowed())
                  {
                     if(IsStopped()==true) return;
                     Print("Trade is not allowed. Sleeping 1sec");
                     Sleep(1000);
                  }
                  resb = OrderModify(res, 0, OrderStopLoss(), OrderTakeProfit(),0,Red);   
                  if(resb != true) Print("Volume Correction: OrderModify() Error: ", GetLastError());
                  else             Print("Volume Correction: SL/TP were set");                              
               } 
               else Print("Volume Correction: Volume increased. New order ticket: ", res);  
            }                        
         }                  
      }  
      return; 
   }
   
   S = CreateSymbolArray();

   for(i=0; i<S; i++)                                                   //    
   {
      sym = SymbolArray[i];
      
      Minlot   =  MarketInfo(sym, MODE_MINLOT);
      Lotstep  =  MarketInfo(sym, MODE_LOTSTEP);
      Maxlot   =  MarketInfo(sym, MODE_MAXLOT);
      slip     =  MarketInfo(sym, MODE_SPREAD);   
      
      V=CountV(sym);
      if(V>0.0)
      {
         lots = D*V;
         lots = (Rounding==1?MathFloor(lot/Lotstep):Rounding==2?MathCeil(lot/Lotstep):MathRound(lot/Lotstep))*Lotstep;
         Print("Volume Correction: BUY increasing lot: ", lots);
         
         if(lots < Minlot)
         {
            Print("Volume Correction: Can not increase buy positions, because increasing lot is < minlot"); 
         }
         else if(lots > Maxlot)
         {     
            Print("Volume Correction: Can not increase buy positions, because increasing lot is > maxlot"); 
         }         
         else
         {
            while(!IsTradeAllowed())
            {
               if(IsStopped()==true) return;
               Print("Trade is not allowed. Sleeping 1sec");
               Sleep(1000);
            }  
            RefreshRates();  
            SymBid = MarketInfo(sym,MODE_BID);
            SymAsk = MarketInfo(sym,MODE_ASK);                  
            price = SymAsk;
            if(StopLoss != 0) sl = SymBid - StopLoss*Point;
            else sl = 0;
            if(TakeProfit != 0) tp = SymBid + TakeProfit*Point;
            else tp = 0;
            res = OrderSend(sym, OP_BUY, lots, price, slip, sl, tp, "Volume Correction");
            if(res < 0) Print("Volume Correction: OrderSend() Error: ", GetLastError());
            else        Print("Volume Correction: Volume increased. New order ticket: ", res);
         }
      }

      if(V<0.0)
      {
         V = -1*V;
         lots = D*V;
         lots = (Rounding==1?MathFloor(lot/Lotstep):Rounding==2?MathCeil(lot/Lotstep):MathRound(lot/Lotstep))*Lotstep;
         Print("Volume Correction: SELL increasing lot: ", lots);
         
         if(lots < Minlot)
         {
            Print("Volume Correction: Can not increase sell positions, because increasing lot is < minlot"); 
         }
         else if(lots > Maxlot)
         {     
            Print("Volume Correction: Can not increase sell positions, because increasing lot is > maxlot"); 
         }         
         else
         {
            while(!IsTradeAllowed())
            {
               if(IsStopped()==true) return;
               Print("Trade is not allowed. Sleeping 1sec");
               Sleep(1000);
            }  
            RefreshRates();    
            SymBid = MarketInfo(sym,MODE_BID);
            SymAsk = MarketInfo(sym,MODE_ASK);                 
            price = SymBid;
            if(StopLoss != 0) sl = SymAsk + StopLoss*Point;
            else sl = 0;
            if(TakeProfit != 0) tp = SymAsk - TakeProfit*Point;
            else tp = 0;       
            res = OrderSend(sym, OP_SELL, lots, price, slip, sl, tp, "Volume Correction");
            if(res < 0) Print("Volume Correction: OrderSend() Error: ", GetLastError());
            else        Print("Volume Correction: Volume increased. New order ticket: ", res);
         }
      }      
   }  
}


void Decrease()
{
   int S, total, i, j, res;
   double V, lots, Vol;
   double Minlot, Lotstep;
   double lot;
   string sym;
   
   if (ModeMTS==1)
   {
      total = CreateTicketArraySymbol(999, ""); 
      for(j=0; j<total; j++)
      {
         b=OrderSelect(Ticket[j], SELECT_BY_TICKET);
         sym = OrderSymbol();
         Minlot   =  MarketInfo(sym, MODE_MINLOT);
         Lotstep  =  MarketInfo(sym, MODE_LOTSTEP);
         slip     =  MarketInfo(sym, MODE_SPREAD); 
         lot = (-1)*D*OrderLots();           
         lot = (Rounding==1?MathFloor(lot/Lotstep):Rounding==2?MathCeil(lot/Lotstep):MathRound(lot/Lotstep))*Lotstep;
         Print("Volume Correction: decreasing lot: ", lot);   
         if(lot < Minlot)
         {
            Print("Volume Correction: Can not decrease position ", OrderTicket(), " because decreasing lot is < minlot"); 
         }                 
         else
         {
            while(!IsTradeAllowed())
            {
               if(IsStopped()==true) return;
               Print("Trade is not allowed. Sleeping 1sec");
               Sleep(1000);
            }  
            RefreshRates();   
            SymBid = MarketInfo(sym,MODE_BID);
            SymAsk = MarketInfo(sym,MODE_ASK);            
            if (OrderType()==OP_BUY)               
               res = OrderClose(OrderTicket(), lot, SymBid, slip);
            else    
               res = OrderClose(OrderTicket(), lot, SymAsk, slip);
            if(res == false)  Print("Volume Correction: OrderClose() Error: ", GetLastError());
            else
            {
               Print("Volume Correction: Order ", OrderTicket(), " closed in proportion.");
            }                  
         }                  
      }  
      return; 
   }
   
   S = CreateSymbolArray();

   for(i=0; i<S; i++)                                                   //    
   {
      sym = SymbolArray[i];
      Minlot   =  MarketInfo(sym, MODE_MINLOT);
      Lotstep  =  MarketInfo(sym, MODE_LOTSTEP);
      slip     =  MarketInfo(sym, MODE_SPREAD);  
      
      V=CountV(sym);
      if(V>0.0)
      {
         lots = (-1)*D*V;                                               //.. D<0.0
         lots = (Rounding==1?MathFloor(lot/Lotstep):Rounding==2?MathCeil(lot/Lotstep):MathRound(lot/Lotstep))*Lotstep;
         Print("Volume Correction: BUY decreasing lot: ", lots);
         
         if(lots < Minlot)
         {
            Print("Volume Correction: Can not decrease buy positions, because decreasing lot is < minlot"); 
         }       
         else
         {
            total = CreateTicketArraySymbol(OP_BUY, sym); 
            if(Mode == 1)
            {
               Vol = 0.0;
               for(j=0; j<total; j++)
               {
                  b=OrderSelect(Ticket[j], SELECT_BY_TICKET);
                  Vol += OrderLots();
               }
               
               for(j=0; j<total; j++)
               {
                  b=OrderSelect(Ticket[j], SELECT_BY_TICKET);
                  lot = lots * OrderLots()/Vol;                         //
                  lot = (Rounding==1?MathFloor(lot/Lotstep):Rounding==2?MathCeil(lot/Lotstep):MathRound(lot/Lotstep))*Lotstep;
                  if(lot < Minlot)
                  {
                     Print("Volume Correction: Can not decrease buy position ", OrderTicket(), " because decreasing lot is < minlot"); 
                  }                 
                  else
                  {
                     while(!IsTradeAllowed())
                     {
                        if(IsStopped()==true) return;
                        Print("Trade is not allowed. Sleeping 1sec");
                        Sleep(1000);
                     }  
                     RefreshRates();         
                     SymBid = MarketInfo(sym,MODE_BID);         
                     res = OrderClose(OrderTicket(), lot, SymBid, slip);
                     if(res == false)  Print("Volume Correction: OrderClose() Error: ", GetLastError());
                     else
                     {
                        Print("Volume Correction: Order ", OrderTicket(), " closed in proportion.");
                     }                  
                  }
               
               }
            }
            else if(Mode != 1)
            {
               ArrangeTickets(total, Mode);
               for(j=0; j<total; j++)
               {
                  b=OrderSelect(Ticket[j], SELECT_BY_TICKET);
                  lot = OrderLots();
                  if(lots - lot > 0.0)                                     //  
                  {
                     while(!IsTradeAllowed())
                     {
                        if(IsStopped()==true) return;
                        Print("Trade is not allowed. Sleeping 1sec");
                        Sleep(1000);
                     }  
                     RefreshRates();     
                     SymBid = MarketInfo(sym,MODE_BID);             
                     res = OrderClose(OrderTicket(), lot, SymBid, slip);
                     if(res == false)  Print("Volume Correction: OrderClose() Error: ", GetLastError());
                     else
                     {
                        lots -= lot;
                        Print("Volume Correction: Order ", OrderTicket(), " closed completely.");
                     }
                  }
                  else                                                     //  
                  {
                     while(!IsTradeAllowed())
                     {
                        if(IsStopped()==true) return;
                        Print("Trade is not allowed. Sleeping 1sec");
                        Sleep(1000);
                     }  
                     RefreshRates();   
                     SymBid = MarketInfo(sym,MODE_BID);                
                     res = OrderClose(OrderTicket(), lots, SymBid, slip);
                     if(res == false)  Print("Volume Correction: OrderClose() Error: ", GetLastError());
                     else
                     {
                        lots = 0.0;
                        Print("Volume Correction: Order ", OrderTicket(), " closed partially.");
                        break;
                     }
                  } 
               }
            }
         }
      }

      if(V<0.0)
      {
         V = -1*V;
         lots = (-1)*D*V;                                               //.. D<0
         lots = (Rounding==1?MathFloor(lot/Lotstep):Rounding==2?MathCeil(lot/Lotstep):MathRound(lot/Lotstep))*Lotstep;
         Print("Volume Correction: SELL decreasing lot: ", lots);
         
         if(lots < Minlot)
         {
            Print("Volume Correction: Can not decrease sell positions, because decreasing lot is < minlot"); 
         }
         else
         {
            total = CreateTicketArraySymbol(OP_SELL, sym); 
            if(Mode == 1)
            {
               Vol = 0.0;
               for(j=0; j<total; j++)
               {
                  b=OrderSelect(Ticket[j], SELECT_BY_TICKET);
                  Vol += OrderLots();
               }
               
               for(j=0; j<total; j++)
               {
                  b=OrderSelect(Ticket[j], SELECT_BY_TICKET);
                  lot = lots * OrderLots()/Vol;                         //
                  lot = (Rounding==1?MathFloor(lot/Lotstep):Rounding==2?MathCeil(lot/Lotstep):MathRound(lot/Lotstep))*Lotstep;
                  if(lot < Minlot)
                  {
                     Print("Volume Correction: Can not decrease buy position ", OrderTicket(), " because decreasing lot is < minlot"); 
                  }                 
                  else
                  {
                     while(!IsTradeAllowed())
                     {
                        if(IsStopped()==true) return;
                        Print("Trade is not allowed. Sleeping 1sec");
                        Sleep(1000);
                     }  
                     RefreshRates();     
                     SymAsk = MarketInfo(sym,MODE_ASK);                                  
                     res = OrderClose(OrderTicket(), lot, SymAsk, slip);
                     if(res == false)  Print("Volume Correction: OrderClose() Error: ", GetLastError());
                     else
                     {
                        Print("Volume Correction: Order ", OrderTicket(), " closed in proportion.");
                     }                  
                  }
               
               }
            }
            else if(Mode != 1)    
            {     
               ArrangeTickets(total, Mode);
               for(j=0; j<total; j++)
               {
                  b=OrderSelect(Ticket[j], SELECT_BY_TICKET);
                  lot = OrderLots();
                  if(lots - lot > 0.0)                                     //  
                  {
                     while(!IsTradeAllowed())
                     {
                        if(IsStopped()==true) return;
                        Print("Trade is not allowed. Sleeping 1sec");
                        Sleep(1000);
                     }  
                     RefreshRates();   
                     SymAsk = MarketInfo(sym,MODE_ASK);                                      
                     res = OrderClose(OrderTicket(), lot, SymAsk, slip);
                     if(res == false)  Print("Volume Correction: OrderClose() Error: ", GetLastError());
                     else
                     {
                        lots -= lot;
                        Print("Volume Correction: Order ", OrderTicket(), " closed completely.");
                     }
                  }
                  else                                                     //  
                  {
                     while(!IsTradeAllowed())
                     {
                        if(IsStopped()==true) return;
                        Print("Trade is not allowed. Sleeping 1sec");
                        Sleep(1000);
                     }  
                     RefreshRates();  
                     SymAsk = MarketInfo(sym,MODE_ASK);                                       
                     res = OrderClose(OrderTicket(), lots, SymAsk, slip);
                     if(res == false)  Print("Volume Correction: OrderClose() Error: ", GetLastError());
                     else
                     {
                        lots = 0.0;
                        Print("Volume Correction: Order ", OrderTicket(), " closed partially.");
                        break;
                     }
                  } 
               }
            }
         }
      }      
   }  
}

// v5.0 DoPendings -   
void DoPendings()
{
   double orders[][3], temp;
   int size=0;
   bool stop=false;

   RefreshRates();
   ArrayResize(orders, 0);
   for(int i=0; i<OrdersTotal(); i++)
   {
      if(OrderSelect(i, SELECT_BY_POS) && OrderType()>1)
      {
         ArrayResize(orders, size+1);
         orders[size][0]=OrderTicket();
         orders[size][1]=OrderLots();
         orders[size][2]=OrderDist();
         size++;
      }
   }
   if(size<1)  return;
   // Sort
   while(!stop)
   {
      stop=true;
      for(i=1; i<size; i++)
      {
         if((PendMode==1 && orders[i][1]>orders[i-1][1]) || (PendMode==2 && orders[i][2]<orders[i-1][2]))
         {
            temp=orders[i-1][0]; orders[i-1][0]=orders[i][0]; orders[i][0]=temp;
            temp=orders[i-1][1]; orders[i-1][1]=orders[i][1]; orders[i][1]=temp;
            temp=orders[i-1][2]; orders[i-1][2]=orders[i][2]; orders[i][2]=temp;
            stop=false;
         }
      }
   }
   // Correct
   for(i=0; i<size; i++)
   {
      if(OrderSelect(orders[i][0], SELECT_BY_TICKET) && (orders[i][2]>=MinDistance*_point() || -D*100>=ForcedDecrease))
      {
         string symbol=OrderSymbol(), comm=OrderComment();
         int type=OrderType(), exp=OrderExpiration(), magic=OrderMagicNumber();
         double price=OrderOpenPrice(), sl=OrderStopLoss(), tp=OrderTakeProfit();
         double lots=OrderLots(), new_lots=NormalizeDouble(lots*(1+D), 2);
         new_lots=MathMax(MarketInfo(symbol, MODE_MINLOT), MathMin(MarketInfo(symbol, MODE_MAXLOT), new_lots));
         if(MathAbs(lots-new_lots)>=MarketInfo(symbol, MODE_MINLOT))
         {
            if(!WaitContext() || !WaitConnect())
            {
               Print("Context busy or no connection. Pending orders correction failed!");
               return;
            }  
            if(OrderDelete(OrderTicket()))
            {
               b=OrderSend(symbol, type, new_lots, price, 0, sl, tp, comm, magic, exp);
            }
            RefreshRates();
         }
      }
   }
}

//# 
double CountV(string symbol)
{
   int total, i;
   double V = 0.0;
      
   total = CreateTicketArraySymbol(OP_BUY, symbol);
   for(i=0; i<total; i++)
   {
      b=OrderSelect(Ticket[i], SELECT_BY_TICKET);
      V += OrderLots();     
   }      

   total = CreateTicketArraySymbol(OP_SELL, symbol);
   for(i=0; i<total; i++)
   {
      b=OrderSelect(Ticket[i], SELECT_BY_TICKET);
      V -= OrderLots();     
   } 

   return(V);
}


int CreateSymbolArray()                                                 //     .  - .
{
   int total, i, j, S=0;
   string sym;
      
   total = OrdersTotal();
   for(i=0; i<total; i++)
   {   
      b=OrderSelect(i, SELECT_BY_POS);   //v2.0
      sym = OrderSymbol();   
      
      for(j=0; j<S; j++)                                                //      
      {
         if(sym == SymbolArray[j])                                
            break;
      }
      
      if(j == S)                                                        //     -    
      {
         SymbolArray[S] = sym;
         S++;
      }   
   }
   
   return(S);   
}

int CreateTicketArraySymbol(int dir, string symbol)                     //           Ticket[].  - .
{
   int total=OrdersTotal(), i, c=0; 
   if (total<=0) return (0);
	
	for(i=0;i<total;i++) 
	{ 
	  b=OrderSelect(i, SELECT_BY_POS); 
	  if (((OrderType()==dir) && (OrderSymbol()==symbol))||((dir==999)&&((OrderType()==OP_BUY)||(OrderType()==OP_SELL))))
	  {
	     Ticket[c] = OrderTicket(); 
	     c++; 
	  } 
	}
	
	return (c);   
}

void ArrangeTickets(int total, int mode)
{
/*
   1.    
   2.      
   3.      
   4.       
   5.        
*/

   int i, j;
  
   for(i=0; i<total; i++)
   {
      b=OrderSelect(Ticket[i], SELECT_BY_TICKET);
      Ticket2[i][0] = Ticket[i];                                                               
      Ticket2[i][1] = NormalizeDouble(OrderProfit() + OrderCommission() + OrderSwap(), 2);
      Ticket2[i][2] = OrderLots();
      Ticket2[i][3] = OrderOpenTime();
   }

   switch(mode)
   {
      case 1:  return;
      case 2:  for(i=0; i<total; i++)
                  for(j=0; j<total-1; j++)                              //   
                  {                                                     //    <>
                     if(Ticket2[j][1] - Ticket2[j+1][1] > 0.0)          //  
                     {
                        Ticket2[1000][0] = Ticket2[j][0];
                        Ticket2[1000][1] = Ticket2[j][1];
                        Ticket2[1000][2] = Ticket2[j][2];
                        Ticket2[1000][3] = Ticket2[j][3];   

                        Ticket2[j][0] = Ticket2[j+1][0];
                        Ticket2[j][1] = Ticket2[j+1][1];
                        Ticket2[j][2] = Ticket2[j+1][2];
                        Ticket2[j][3] = Ticket2[j+1][3];   

                        Ticket2[j+1][0] = Ticket2[1000][0];
                        Ticket2[j+1][1] = Ticket2[1000][1];
                        Ticket2[j+1][2] = Ticket2[1000][2];
                        Ticket2[j+1][3] = Ticket2[1000][3];                                          
                     }
                  }
               break;     
      case 3:  for(i=0; i<total; i++)
                  for(j=0; j<total-1; j++)                              //   
                  {                                                     //    <>
                     if(Ticket2[j][1] - Ticket2[j+1][1] < 0.0)          //  
                     {
                        Ticket2[1000][0] = Ticket2[j][0];
                        Ticket2[1000][1] = Ticket2[j][1];
                        Ticket2[1000][2] = Ticket2[j][2];
                        Ticket2[1000][3] = Ticket2[j][3];   

                        Ticket2[j][0] = Ticket2[j+1][0];
                        Ticket2[j][1] = Ticket2[j+1][1];
                        Ticket2[j][2] = Ticket2[j+1][2];
                        Ticket2[j][3] = Ticket2[j+1][3];   

                        Ticket2[j+1][0] = Ticket2[1000][0];
                        Ticket2[j+1][1] = Ticket2[1000][1];
                        Ticket2[j+1][2] = Ticket2[1000][2];
                        Ticket2[j+1][3] = Ticket2[1000][3];                                          
                     }
                  }
               break;
      case 4:  for(i=0; i<total; i++)
                  for(j=0; j<total-1; j++)                              //   
                  {                                                     //    <>
                     if(Ticket2[j][2] - Ticket2[j+1][2] > 0.0)          //  
                     {
                        Ticket2[1000][0] = Ticket2[j][0];
                        Ticket2[1000][1] = Ticket2[j][1];
                        Ticket2[1000][2] = Ticket2[j][2];
                        Ticket2[1000][3] = Ticket2[j][3];   

                        Ticket2[j][0] = Ticket2[j+1][0];
                        Ticket2[j][1] = Ticket2[j+1][1];
                        Ticket2[j][2] = Ticket2[j+1][2];
                        Ticket2[j][3] = Ticket2[j+1][3];   

                        Ticket2[j+1][0] = Ticket2[1000][0];
                        Ticket2[j+1][1] = Ticket2[1000][1];
                        Ticket2[j+1][2] = Ticket2[1000][2];
                        Ticket2[j+1][3] = Ticket2[1000][3];                                          
                     }
                  }                   
               break;
      case 5:  for(i=0; i<total; i++)
                  for(j=0; j<total-1; j++)                              //   
                  {                                                     //    < >
                     if(Ticket2[j][3] - Ticket2[j+1][3] < 0.0)          //  
                     {
                        Ticket2[1000][0] = Ticket2[j][0];
                        Ticket2[1000][1] = Ticket2[j][1];
                        Ticket2[1000][2] = Ticket2[j][2];
                        Ticket2[1000][3] = Ticket2[j][3];   

                        Ticket2[j][0] = Ticket2[j+1][0];
                        Ticket2[j][1] = Ticket2[j+1][1];
                        Ticket2[j][2] = Ticket2[j+1][2];
                        Ticket2[j][3] = Ticket2[j+1][3];   

                        Ticket2[j+1][0] = Ticket2[1000][0];
                        Ticket2[j+1][1] = Ticket2[1000][1];
                        Ticket2[j+1][2] = Ticket2[1000][2];
                        Ticket2[j+1][3] = Ticket2[1000][3];                                          
                     }
                  }    
               break;   
   }

   for(i=0; i<total; i++)
   {
      Ticket[i] = Ticket2[i][0];
   }
}

bool WaitContext(){
   uint tick;
   if( IsTradeContextBusy () ){
      tick=GetTickCount();
      Print("   ...");
      while( true ){
         if (MathAbs( GetTickCount()-tick )>SEC_WAIT*1000 || GetTickCount()<tick ){
            Print("  ");
            return( false );
         }
         if( !IsTradeContextBusy() ){
            Print("   "+(GetTickCount()-tick)+" ");
            return( true );
         }
         Sleep( MS_WAIT );
      }
   }
   return( true );
}

bool WaitConnect(){
   uint tick;
   if( !IsConnected () ){
      tick=GetTickCount();
      Print("    ...");
      while( true ){
         if (MathAbs( GetTickCount()-tick )>SEC_WAIT*1000 || GetTickCount()<tick ){
            Print("  ");
            return( false );
         }
         if( !IsTradeContextBusy() ){
            Print("   "+(GetTickCount()-tick)+" ");
            return( true );
         }
         Sleep( MS_WAIT );
      }
   }
   return( true );
}

double OrderDist()
{
   double dist=0;
   switch(OrderType())
   {
      case OP_BUYSTOP:     dist=OrderOpenPrice()-_ask(); break;
      case OP_SELLSTOP:    dist=_bid()-OrderOpenPrice(); break;
      case OP_BUYLIMIT:    dist=_ask()-OrderOpenPrice(); break;
      case OP_SELLLIMIT:   dist=OrderOpenPrice()-_bid(); break;
   }
   return(dist);
}

double _ask(){ return(MarketInfo(OrderSymbol(), MODE_ASK)); }
double _bid(){ return(MarketInfo(OrderSymbol(), MODE_BID)); }
double _point(){ return(MarketInfo(OrderSymbol(), MODE_POINT)); }


